/*****************************************************
This program was produced by the
CodeWizardAVR V2.05.0 Professional
Automatic Program Generator
 Copyright 1998-2010 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : 
Version : 
Date    : 12.04.2011
Author  : 
Company : 
Comments: 


Chip type               : ATmega8
Program type            : Application
AVR Core Clock frequency: 8,000000 MHz
Memory model            : Small
External RAM size       : 0
Data Stack size         : 256
*****************************************************/

#include <mega8.h>

volatile unsigned char Mode; //  
#define Off 0                    //  
#define First_On 1            //    
#define On 2                   //   ( )
#define Off_Ready 3        //    
#define Brightness_Change 4        //   
volatile unsigned char  Button_State; //  
volatile unsigned char Prev_PIN_State = 1;    //    
volatile unsigned char PIN_State;    //    0  1
volatile unsigned char PIN_Change;  //    (  )
#define Changed 1
#define Unchanged 0
#define Button_Pushed (!PINB.0)

eeprom unsigned char Brightness = 125;

volatile unsigned char Time; //    

// Time 0 overflow interrupt service routine
//   8 mS
interrupt [TIM0_OVF] void Time0_ovf_isr(void)
{ 
    Time++;                                     //   
    PIN_State = PINB.0;              //    
    if (PIN_State ==!Prev_PIN_State)  //     
    {  
        Button_State = PIN_State;       //    
        PIN_Change = Changed;               //   
        Time = 0;                              //     
    };
    
    if (PIN_Change == Changed)                   
    {                                            //   
        if (Time == 5)                    //   8ms x 5 = 40mS 
            {  
                if (Button_State == PIN_State) //    
                {                                          //    
                    if Button_Pushed                //    
                    {  
                        Time = 0;                     //   
                        switch (Mode)              //  
                        {
                             case Off:                  // 
                             {
                                Mode = First_On;       //  
                                OCR2 =  Brightness;   //                    
                                break;
                             };
                             case On:                  //    
                             {  
                                Mode = Off_Ready;
                                break;
                             };
                        };  
                    }
                    else                                //    
                    {  
                        switch (Mode)              //  
                        {
                            case Off_Ready:       //     
                            {
                                Mode = Off;         //  
                                OCR2 = 0;
                            };
                            break;
                           
                            case First_On:       //     
                            {
                                Mode = On;         //    
                            };
                            break;
                    
                            case Brightness_Change:   //   
                            {
                                Brightness = OCR2;  //  
                                Mode = On;         //    
                            };
                            break;
                        };
                    };  
                };               
                PIN_Change = Unchanged;      //  
            };        
    };
    
     //   8ms x 125 = 1  
    if (((Mode == First_On) | (Mode == Off_Ready)) & (Time == 125) & (Button_Pushed))       
    {  Mode = Brightness_Change; };  //      
    
    //        -  
    if ((Mode == Brightness_Change) & (Button_Pushed)) OCR2++;                                                               
                     
    Prev_PIN_State = PIN_State;     //     

}

// Declare your global variables here

void main(void)
{
// Declare your local variables here

// Input/Output Ports initialization
// Port B initialization
// Func7=In Func6=In Func5=In Func4=In Func3=Out Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=0 State2=T State1=T State0=P 
PORTB=0x01;
DDRB=0x08;

// Port C initialization
// Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTC=0x00;
DDRC=0x00;

// Port D initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTD=0x00;
DDRD=0x00;

// Time/Counter 0 initialization
// Clock source: System Clock
// Clock value: 31,250 kHz
TCCR0=0x04;
TCNT0=0x00;

// Time/Counter 2 initialization
// Clock source: System Clock
// Clock value: 7,813 kHz
// Mode: Fast PWM top=0xFF
// OC2 output: Non-Inverted PWM
ASSR=0x00;
TCCR2=0x6F;
TCNT2=0x00;
OCR2=0x00;

// Time(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x01;

// Global enable interrupts
#asm("sei")

while (1)
      {
      // Place your code here
      
      }
}
